; =========================================================
; aluno: MARCOS VINICIUS MATSUO		matricula: 05141354
; =========================================================
;TIMER 0 - MODO 1 (contador de 16 bits) - gera a frequncia de 1,901KHz
;TIMER 1 - MODO 2 (contador de 08 bits recarregavel automaticamente) - gera a frequncia de 2 Khz

	ORG 0000H	;endereo inicial do cdigo do programa
	LJMP INICIO	;desvio para o inicio do programa 
			; (para pular pelos tratadores de interrupo)

	ORG 000BH	;tratador de interrupo do timer0
	JMP TIMER0      ;desvio para a parte da memoria onde a interrupo do timer0 ser tratada

	ORG 001BH	;tratador de interrupo do timer1
	JMP TIMER1      ;desvio para a parte da memoria onde a interrupo do timer1 ser tratada

	;INICIALIZAO
INICIO:	MOV TMOD,#21H	;timer0 modo1 (16bits) - timer1 modo2 (8 bits)
	MOV TH1,#06H	;valor a ser carregado automticamente no timer1, 
			; depois de um overflow
	SETB TF0	;seta flag do timer0, para forar a primeira interrupo, de forma 
			; que o timer0 inicie a primeira contagem com o valor correto
	SETB TR1	;habilita contagem do timer1
	MOV IE,#8AH	;habilitao da sinterrupes dos timers 0 e 1


	;CONTADOR EM  R7 DO BANCO 4
	SETB RS1	;seleo do BANCO 4 - RS1 = 1 ; RS0 = 1
	SETB RS0
	MOV R7,#00H	;move o valor 00H para R7 do BANCO 4
	MOV P2,R7	;move o valor do refistro R7 para o registro P2, de forma
			; a ser mostrado na porta 2
	ACALL ATRASO    ;chama rotina de atraso

LOOP:	INC R7		;incrementa o valor em R7 do BANCO 4
	MOV P2,R7	;move o valor de R7 para o registro P2, de forma 
			; a ser mostrado na porta 2
	ACALL ATRASO	;chama rotina de atraso, para poder visualizar a contagem
	JMP LOOP	;pula para LOOP
 	

	;ROTINA DE ATRASO - de forma que se possa acompanhar a contagem
ATRASO:	MOV R0,#00H		;move o valor 00H para R0 do BANCO 4

ATRS1:	INC R0		        ;incrementa registro R0
	CJNE R0,#0FFH,ATRS1	;compara o valor em R0 com o valor FFH, enquanto 
				; no forem iguais pula  para ATRS1
	RET			;retorna ao programa principal
	

	;TRATADOR DO TIMER1 (MODO 2 - CONTADOR DE 8 BITS) - frequencia de 2 Khz
TIMER1:	CPL P0.4 	;complementa sinal no bit 4 da PORTA 0
	RETI		;retorna ao programa


	;TRATADOR DO TIMER0 (MODO 1 - CONTADOR DE 16 BITS) - frequncia de 1,901 Khz
TIMER0:	CLR TF0		;zera flag do timer0		
	CLR TR0		;pra a contagem
	CPL P0.3	;complementa sinal no bit 3 da PORTA 0
	MOV TH0,#0FEH	;carrega o TIMER 0 com o valor incial de FEF9H
	MOV TL0,#0F9H	;de modo a passar pelo tempo correto para complementar novamente P0.3
	SETB TR0	;habilita a contagem do TIMER 0
	RETI		;retorna ao programa

	END


